#!/usr/bin/env node
;
var ASCIIDrawing, ASCIIMapping, CSVDrawing, CoffeeMapping, Context, DOMParser, DSVDrawing, Drawing, Drawings, DynamicSymbol, Input, JSMapping, Mapping, Mappings, SSVDrawing, SVGNS, SVGTilerException, StaticSymbol, Symbol, TSVDrawing, XLINKNS, XLSXDrawings, XMLSerializer, allBlank, blankCells, domImplementation, extensionMap, extensionOf, fs, help, main, overflowBox, path, prettyXML, splitIntoLines, svg2, svgBBox, whitespace, xmldom, zIndex, zeroSizeReplacement,
  indexOf = [].indexOf || function(item) { for (var i = 0, l = this.length; i < l; i++) { if (i in this && this[i] === item) return i; } return -1; },
  extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty,
  slice = [].slice;

path = require('path');

fs = require('fs');

xmldom = require('xmldom');

DOMParser = xmldom.DOMParser;

domImplementation = new xmldom.DOMImplementation();

XMLSerializer = xmldom.XMLSerializer;

prettyXML = require('prettify-xml');

SVGNS = 'http://www.w3.org/2000/svg';

XLINKNS = 'http://www.w3.org/1999/xlink';

splitIntoLines = function(data) {
  return data.replace('\r\n', '\n').replace('\r', '\n').split('\n');
};

whitespace = /[\s\uFEFF\xA0]+/;

extensionOf = function(filename) {
  return path.extname(filename).toLowerCase();
};

SVGTilerException = (function() {
  function SVGTilerException(message) {
    this.message = message;
  }

  SVGTilerException.prototype.toString = function() {
    return "svgtiler: " + this.message;
  };

  return SVGTilerException;

})();

overflowBox = function(xml) {
  if (xml.documentElement.hasAttribute('overflowBox')) {
    return xml.documentElement.getAttribute('overflowBox').split(/\s*,?\s+/).map(parseFloat);
  } else {
    return null;
  }
};

svgBBox = function(xml) {
  var recurse, viewBox;
  if (xml.documentElement.hasAttribute('viewBox')) {
    return xml.documentElement.getAttribute('viewBox').split(/\s*,?\s+/).map(parseFloat);
  } else {
    recurse = function(node) {
      var child, coord, cx, cy, point, points, r, ref, rx, ry, viewBox, viewBoxes, x1, x2, xmax, xmin, xs, y1, y2, ymax, ymin, ys;
      if (node.nodeType !== node.ELEMENT_NODE || ((ref = node.tagName) === 'defs' || ref === 'symbol' || ref === 'use')) {
        return [null, null, null, null];
      }
      switch (node.tagName) {
        case 'rect':
        case 'image':
          return [parseFloat(node.getAttribute('x') || 0), parseFloat(node.getAttribute('y') || 0), parseFloat(node.getAttribute('width') || '100%'), parseFloat(node.getAttribute('height') || '100%')];
        case 'circle':
          cx = parseFloat(node.getAttribute('cx') || 0);
          cy = parseFloat(node.getAttribute('cy') || 0);
          r = parseFloat(node.getAttribute('r') || 0);
          return [cx - r, cy - r, 2 * r, 2 * r];
        case 'ellipse':
          cx = parseFloat(node.getAttribute('cx') || 0);
          cy = parseFloat(node.getAttribute('cy') || 0);
          rx = parseFloat(node.getAttribute('rx') || 0);
          ry = parseFloat(node.getAttribute('ry') || 0);
          return [cx - rx, cy - ry, 2 * rx, 2 * ry];
        case 'line':
          x1 = parseFloat(node.getAttribute('x1') || 0);
          y1 = parseFloat(node.getAttribute('y1') || 0);
          x2 = parseFloat(node.getAttribute('x2') || 0);
          y2 = parseFloat(node.getAttribute('y2') || 0);
          xmin = Math.min(x1, x2);
          ymin = Math.min(y1, y2);
          return [xmin, ymin, Math.max(x1, x2) - xmin, Math.max(y1, y2) - ymin];
        case 'polyline':
        case 'polygon':
          points = (function() {
            var k, len, ref1, results;
            ref1 = node.getAttribute('points').trim().split(/\s+/);
            results = [];
            for (k = 0, len = ref1.length; k < len; k++) {
              point = ref1[k];
              results.push((function() {
                var l, len1, ref2, results1;
                ref2 = point.split(/,/);
                results1 = [];
                for (l = 0, len1 = ref2.length; l < len1; l++) {
                  coord = ref2[l];
                  results1.push(parseFloat(coord));
                }
                return results1;
              })());
            }
            return results;
          })();
          xs = (function() {
            var k, len, results;
            results = [];
            for (k = 0, len = points.length; k < len; k++) {
              point = points[k];
              results.push(point[0]);
            }
            return results;
          })();
          ys = (function() {
            var k, len, results;
            results = [];
            for (k = 0, len = points.length; k < len; k++) {
              point = points[k];
              results.push(point[1]);
            }
            return results;
          })();
          xmin = Math.min.apply(Math, xs);
          ymin = Math.min.apply(Math, ys);
          return [xmin, ymin, Math.max.apply(Math, xs) - xmin, Math.max.apply(Math, ys) - ymin];
        default:
          viewBoxes = (function() {
            var k, len, ref1, results;
            ref1 = node.childNodes;
            results = [];
            for (k = 0, len = ref1.length; k < len; k++) {
              child = ref1[k];
              results.push(recurse(child));
            }
            return results;
          })();
          xmin = Math.min.apply(Math, (function() {
            var k, len, results;
            results = [];
            for (k = 0, len = viewBoxes.length; k < len; k++) {
              viewBox = viewBoxes[k];
              if (viewBox[0]) {
                results.push(viewBox[0]);
              }
            }
            return results;
          })());
          ymin = Math.min.apply(Math, (function() {
            var k, len, results;
            results = [];
            for (k = 0, len = viewBoxes.length; k < len; k++) {
              viewBox = viewBoxes[k];
              if (viewBox[1]) {
                results.push(viewBox[1]);
              }
            }
            return results;
          })());
          xmax = Math.max.apply(Math, (function() {
            var k, len, results;
            results = [];
            for (k = 0, len = viewBoxes.length; k < len; k++) {
              viewBox = viewBoxes[k];
              if (viewBox[0] && viewBox[2]) {
                results.push(viewBox[0] + viewBox[2]);
              }
            }
            return results;
          })());
          ymax = Math.max.apply(Math, (function() {
            var k, len, results;
            results = [];
            for (k = 0, len = viewBoxes.length; k < len; k++) {
              viewBox = viewBoxes[k];
              if (viewBox[1] && viewBox[3]) {
                results.push(viewBox[1] + viewBox[3]);
              }
            }
            return results;
          })());
          return [xmin, ymin, xmax - xmin, ymax - ymin];
      }
    };
    viewBox = recurse(xml.documentElement);
    if (indexOf.call(viewBox, 2e308) >= 0 || indexOf.call(viewBox, -2e308) >= 0) {
      return null;
    } else {
      return viewBox;
    }
  }
};

zIndex = function(node) {
  var match, style;
  style = node.getAttribute('style');
  if (!style) {
    return 0;
  }
  match = /(?:^|\W)z-index\s*:\s*([-\d]+)/i.exec(style);
  if (match == null) {
    return 0;
  }
  return parseInt(match[1]);
};

Symbol = (function() {
  function Symbol() {}

  Symbol.svgEncoding = 'utf8';

  Symbol.forceWidth = null;

  Symbol.forceHeight = null;


  /*
  Attempt to render pixels as pixels, as needed for old-school graphics.
  SVG 1.1 and Inkscape define image-rendering="optimizeSpeed" for this.
  Chrome doesn't support this, but supports a CSS3 (or SVG) specification of
  "image-rendering:pixelated".  Combining these seems to work everywhere.
   */

  Symbol.imageRendering = ' image-rendering="optimizeSpeed" style="image-rendering:pixelated"';

  Symbol.parse = function(key, data) {
    var extension, size;
    if (data == null) {
      throw new SVGTilerException("Attempt to create symbol '" + key + "' without data");
    } else if (typeof data === 'function') {
      return new DynamicSymbol(key, data);
    } else if (data["function"] != null) {
      return new DynamicSymbol(key, data["function"]);
    } else {
      return new StaticSymbol(key, (function() {
        if (typeof data === 'string') {
          if (data.indexOf('<') < 0) {
            extension = extensionOf(data);
            switch (extension) {
              case '.png':
              case '.jpg':
              case '.jpeg':
              case '.gif':
                size = require('image-size')(data);
                return {
                  svg: "<image xlink:href=\"" + (encodeURIComponent(data)) + "\" width=\"" + size.width + "\" height=\"" + size.height + "\"" + this.imageRendering + "/>"
                };
              case '.svg':
                return {
                  filename: data,
                  svg: fs.readFileSync(data, {
                    encoding: this.svgEncoding
                  })
                };
              default:
                throw new SVGTilerException("Unrecognized extension in filename '" + data + "' for symbol '" + key + "'");
            }
          } else {
            return {
              svg: data
            };
          }
        } else {
          return data;
        }
      }).call(this));
    }
  };

  Symbol.prototype.includes = function(substring) {
    return this.key.indexOf(substring) >= 0;
  };

  return Symbol;

})();

zeroSizeReplacement = 1;

StaticSymbol = (function(superClass) {
  extend(StaticSymbol, superClass);

  function StaticSymbol(key1, options) {
    var key, value, warnings;
    this.key = key1;
    for (key in options) {
      if (!hasProp.call(options, key)) continue;
      value = options[key];
      this[key] = value;
    }
    this.xml = new DOMParser().parseFromString(this.svg);
    this.viewBox = svgBBox(this.xml);
    this.overflowBox = overflowBox(this.xml);
    this.width = this.height = null;
    if (this.viewBox != null) {
      this.width = this.viewBox[2];
      this.height = this.viewBox[3];

      /*
      SVG's viewBox has a special rule that "A value of zero [in <width>
      or <height>] disables rendering of the element."  Avoid this.
      [https://www.w3.org/TR/SVG11/coords.html#ViewBoxAttribute]
       */
      if (this.xml.documentElement.hasAttribute('style') && /overflow\s*:\s*visible/.test(this.xml.documentElement.getAttribute('style'))) {
        if (this.width === 0) {
          this.viewBox[2] = zeroSizeReplacement;
        }
        if (this.height === 0) {
          this.viewBox[3] = zeroSizeReplacement;
        }
      }
    }
    if (Symbol.forceWidth != null) {
      this.width = Symbol.forceWidth;
    }
    if (Symbol.forceHeight != null) {
      this.height = Symbol.forceHeight;
    }
    warnings = [];
    if (this.width == null) {
      warnings.push('width');
      if (this.width == null) {
        this.width = 0;
      }
    }
    if (this.height == null) {
      warnings.push('height');
      if (this.height == null) {
        this.height = 0;
      }
    }
    if (warnings.length > 0) {
      console.warn("Failed to detect " + (warnings.join(' and ')) + " of SVG for symbol '" + this.key + "'");
    }
    this.zIndex = zIndex(this.xml.documentElement);
  }

  StaticSymbol.prototype.id = function() {

    /*
    id/href follows the IRI spec [https://tools.ietf.org/html/rfc3987]:
      ifragment      = *( ipchar / "/" / "?" )
      ipchar         = iunreserved / pct-encoded / sub-delims / ":" / "@"
      iunreserved    = ALPHA / DIGIT / "-" / "." / "_" / "~" / ucschar
      pct-encoded    = "%" HEXDIG HEXDIG
      sub-delims     = "!" / "$" / "&" / "'" / "(" / ")"
                     / "*" / "+" / "," / ";" / "="
      ucschar        = %xA0-D7FF / %xF900-FDCF / #%xFDF0-FFEF
                     / %x10000-1FFFD / %x20000-2FFFD / %x30000-3FFFD
                     / %x40000-4FFFD / %x50000-5FFFD / %x60000-6FFFD
                     / %x70000-7FFFD / %x80000-8FFFD / %x90000-9FFFD
                     / %xA0000-AFFFD / %xB0000-BFFFD / %xC0000-CFFFD
                     / %xD0000-DFFFD / %xE1000-EFFFD
    We also want to escape colon (:) which seems to cause trouble.
    We use encodeURIComponent which escapes everything except
      A-Z a-z 0-9 - _ . ! ~ * ' ( )
    [https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/encodeURIComponent]
    Unfortunately, Inkscape seems to ignore any %-encoded symbols; see
    https://bugs.launchpad.net/inkscape/+bug/1737778
    So we replace '%' with '$', an allowed character that's already escaped.
     */
    return encodeURIComponent(this.key).replace(/%/g, '$');
  };

  return StaticSymbol;

})(Symbol);

DynamicSymbol = (function(superClass) {
  extend(DynamicSymbol, superClass);

  function DynamicSymbol(key1, func) {
    this.key = key1;
    this.func = func;
    this.versions = {};
    this.nversions = 0;
  }

  DynamicSymbol.prototype.use = function(context) {
    var result;
    result = this.func.call(context);
    if (result in this.versions) {
      return this.versions[result];
    } else {
      return this.versions[result] = Symbol.parse(this.key + "-v" + (this.nversions++), result);
    }
  };

  return DynamicSymbol;

})(Symbol);

Input = (function() {
  function Input() {}

  Input.encoding = 'utf8';

  Input.parseFile = function(filename) {
    var input;
    input = this.parse(fs.readFileSync(filename, {
      encoding: this.encoding
    }));
    input.filename = filename;
    return input;
  };

  Input.load = function(filename) {
    var extension;
    extension = extensionOf(filename);
    if (extension in extensionMap) {
      return extensionMap[extension].parseFile(filename);
    } else {
      throw new SVGTilerException("Unrecognized extension in filename " + filename);
    }
  };

  return Input;

})();

Mapping = (function(superClass) {
  extend(Mapping, superClass);

  function Mapping(data) {
    this.map = {};
    if (typeof data === 'function') {
      this["function"] = data;
    } else {
      this.merge(data);
    }
  }

  Mapping.prototype.merge = function(data) {
    var key, results, value;
    results = [];
    for (key in data) {
      if (!hasProp.call(data, key)) continue;
      value = data[key];
      if (!(value instanceof Symbol)) {
        value = Symbol.parse(key, value);
      }
      results.push(this.map[key] = value);
    }
    return results;
  };

  Mapping.prototype.lookup = function(key) {
    var value;
    if (key in this.map) {
      return this.map[key];
    } else if (this["function"] != null) {
      value = this["function"](key);
      if (value != null) {
        return this.map[key] = Symbol.parse(key, value);
      } else {
        return value;
      }
    } else {
      return void 0;
    }
  };

  return Mapping;

})(Input);

ASCIIMapping = (function(superClass) {
  extend(ASCIIMapping, superClass);

  function ASCIIMapping() {
    return ASCIIMapping.__super__.constructor.apply(this, arguments);
  }

  ASCIIMapping.title = "ASCII mapping file";

  ASCIIMapping.help = "Each line is <symbol-name><space><raw SVG or filename.svg>";

  ASCIIMapping.parse = function(data) {
    var k, key, len, line, map, ref, separator;
    map = {};
    ref = splitIntoLines(data);
    for (k = 0, len = ref.length; k < len; k++) {
      line = ref[k];
      separator = whitespace.exec(line);
      if (separator == null) {
        continue;
      }
      if (separator.index === 0) {
        if (separator[0].length === 1) {
          key = '';
        } else {
          key = line[0];
        }
      } else {
        key = line.slice(0, separator.index);
      }
      map[key] = line.slice(separator.index + separator[0].length);
    }
    return new this(map);
  };

  return ASCIIMapping;

})(Mapping);

JSMapping = (function(superClass) {
  extend(JSMapping, superClass);

  function JSMapping() {
    return JSMapping.__super__.constructor.apply(this, arguments);
  }

  JSMapping.title = "JavaScript mapping file";

  JSMapping.help = "Object mapping symbol names to SYMBOL e.g. dot: 'dot.svg'";

  JSMapping.parse = function(data) {
    return new this(eval(data));
  };

  return JSMapping;

})(Mapping);

CoffeeMapping = (function(superClass) {
  extend(CoffeeMapping, superClass);

  function CoffeeMapping() {
    return CoffeeMapping.__super__.constructor.apply(this, arguments);
  }

  CoffeeMapping.title = "CoffeeScript mapping file";

  CoffeeMapping.help = "Object mapping symbol names to SYMBOL e.g. dot: 'dot.svg'";

  CoffeeMapping.parse = function(data) {
    return new this(require('coffee-script')["eval"](data));
  };

  return CoffeeMapping;

})(Mapping);

Mappings = (function() {
  function Mappings(maps) {
    this.maps = maps != null ? maps : [];
  }

  Mappings.prototype.push = function(map) {
    return this.maps.push(map);
  };

  Mappings.prototype.lookup = function(key) {
    var i, k, ref, value;
    if (!this.maps.length) {
      return;
    }
    for (i = k = ref = this.maps.length - 1; ref <= 0 ? k <= 0 : k >= 0; i = ref <= 0 ? ++k : --k) {
      value = this.maps[i].lookup(key);
      if (value != null) {
        return value;
      }
    }
    return void 0;
  };

  return Mappings;

})();

blankCells = {
  '': true,
  ' ': true
};

allBlank = function(list) {
  var k, len, x;
  for (k = 0, len = list.length; k < len; k++) {
    x = list[k];
    if ((x != null) && !(x in blankCells)) {
      return false;
    }
  }
  return true;
};

Drawing = (function(superClass) {
  extend(Drawing, superClass);

  function Drawing(data1) {
    this.data = data1;
  }

  Drawing.load = function(data) {
    var cell, j, k, l, len, len1, row;
    data = (function() {
      var k, len, results;
      results = [];
      for (k = 0, len = data.length; k < len; k++) {
        row = data[k];
        results.push((function() {
          var l, len1, results1;
          results1 = [];
          for (l = 0, len1 = row.length; l < len1; l++) {
            cell = row[l];
            results1.push(cell);
          }
          return results1;
        })());
      }
      return results;
    })();
    if (!Drawing.keepMargins) {
      while (data.length > 0 && allBlank(data[0])) {
        data.shift();
      }
      while (data.length > 0 && allBlank(data[data.length - 1])) {
        data.pop();
      }
      if (data.length > 0) {
        while (allBlank((function() {
            var l, len1, results;
            results = [];
            for (l = 0, len1 = data.length; l < len1; l++) {
              row = data[l];
              results.push(row[0]);
            }
            return results;
          })())) {
          for (k = 0, len = data.length; k < len; k++) {
            row = data[k];
            row.shift();
          }
        }
        j = Math.max.apply(Math, (function() {
          var l, len1, results;
          results = [];
          for (l = 0, len1 = data.length; l < len1; l++) {
            row = data[l];
            results.push(row.length);
          }
          return results;
        })());
        while (j >= 0 && allBlank((function() {
            var len2, m, results;
            results = [];
            for (m = 0, len2 = data.length; m < len2; m++) {
              row = data[m];
              results.push(row[j]);
            }
            return results;
          })())) {
          for (l = 0, len1 = data.length; l < len1; l++) {
            row = data[l];
            if (j < row.length) {
              row.pop();
            }
          }
          j--;
        }
      }
    }
    return new this(data);
  };

  Drawing.prototype.writeSVG = function(mappings, filename) {
    if (filename == null) {
      filename = path.parse(this.filename);
      if (filename.ext === '.svg') {
        filename.base += '.svg';
      } else {
        filename.base = filename.base.slice(0, -filename.ext.length) + '.svg';
      }
      filename = path.format(filename);
    }
    console.log('->', filename);
    fs.writeFileSync(filename, this.renderSVG(mappings));
    return filename;
  };

  Drawing.prototype.renderSVG = function(mappings) {
    var attribute, cell, child, doc, dx, dy, i, j, k, key, l, len, len1, len2, len3, len4, len5, level, levelOrder, levels, m, missing, n, name, node, o, out, p, ref, ref1, ref2, ref3, ref4, ref5, ref6, ref7, ref8, row, rowHeight, svg, symbol, symbols, symbolsByKey, use, viewBox, x, y;
    doc = domImplementation.createDocument(SVGNS, 'svg');
    svg = doc.documentElement;
    svg.setAttribute('xmlns:xlink', XLINKNS);
    svg.setAttribute('version', '1.1');
    missing = {};
    symbols = (function() {
      var k, len, ref, results;
      ref = this.data;
      results = [];
      for (k = 0, len = ref.length; k < len; k++) {
        row = ref[k];
        results.push((function() {
          var l, len1, results1;
          results1 = [];
          for (l = 0, len1 = row.length; l < len1; l++) {
            cell = row[l];
            symbol = mappings.lookup(cell);
            if (symbol == null) {
              missing[cell] = true;
            }
            results1.push(symbol);
          }
          return results1;
        })());
      }
      return results;
    }).call(this);
    missing = (function() {
      var results;
      results = [];
      for (key in missing) {
        if (!hasProp.call(missing, key)) continue;
        results.push("'" + key + "'");
      }
      return results;
    })();
    if (missing.length) {
      console.warn("Failed to recognize symbols:", missing.join(', '));
    }
    symbolsByKey = {};
    symbols = (function() {
      var k, len, results;
      results = [];
      for (i = k = 0, len = symbols.length; k < len; i = ++k) {
        row = symbols[i];
        results.push((function() {
          var l, len1, results1;
          results1 = [];
          for (j = l = 0, len1 = row.length; l < len1; j = ++l) {
            symbol = row[j];
            if ((symbol != null ? symbol.use : void 0) != null) {
              symbol = symbol.use(new Context(symbols, i, j));
            }
            results1.push(symbolsByKey[symbol != null ? symbol.key : void 0] = symbol);
          }
          return results1;
        })());
      }
      return results;
    })();
    for (key in symbolsByKey) {
      symbol = symbolsByKey[key];
      if (symbol == null) {
        continue;
      }
      svg.appendChild(node = doc.createElementNS(SVGNS, 'symbol'));
      node.setAttribute('id', symbol.id());
      if ((ref = symbol.xml.documentElement.tagName) === 'svg' || ref === 'symbol') {
        ref1 = symbol.xml.documentElement.attributes;
        for (k = 0, len = ref1.length; k < len; k++) {
          attribute = ref1[k];
          if (!(((ref2 = attribute.name) === 'version') || attribute.name.slice(0, 5) === 'xmlns')) {
            node.setAttribute(attribute.name, attribute.value);
          }
        }
        ref3 = symbol.xml.documentElement.childNodes;
        for (l = 0, len1 = ref3.length; l < len1; l++) {
          child = ref3[l];
          node.appendChild(child.cloneNode(true));
        }
      } else {
        node.appendChild(symbol.xml.documentElement.cloneNode(true));
      }
      if (symbol.viewBox != null) {
        node.setAttribute('viewBox', symbol.viewBox);
      }
    }
    viewBox = [0, 0, 0, 0];
    levels = {};
    y = 0;
    for (i = m = 0, len2 = symbols.length; m < len2; i = ++m) {
      row = symbols[i];
      rowHeight = 0;
      x = 0;
      for (j = n = 0, len3 = row.length; n < len3; j = ++n) {
        symbol = row[j];
        if (symbol == null) {
          continue;
        }
        if (levels[name = symbol.zIndex] == null) {
          levels[name] = [];
        }
        levels[symbol.zIndex].push(use = doc.createElementNS(SVGNS, 'use'));
        use.setAttribute('xlink:href', '#' + symbol.id());
        use.setAttributeNS(SVGNS, 'x', x);
        use.setAttributeNS(SVGNS, 'y', y);
        use.setAttributeNS(SVGNS, 'width', (ref4 = (ref5 = symbol.viewBox) != null ? ref5[2] : void 0) != null ? ref4 : symbol.width);
        use.setAttributeNS(SVGNS, 'height', (ref6 = (ref7 = symbol.viewBox) != null ? ref7[3] : void 0) != null ? ref6 : symbol.height);
        if (symbol.overflowBox != null) {
          dx = symbol.overflowBox[0] - symbol.viewBox[0];
          dy = symbol.overflowBox[1] - symbol.viewBox[1];
          viewBox[0] = Math.min(viewBox[0], x + dx);
          viewBox[1] = Math.min(viewBox[1], y + dy);
          viewBox[2] = Math.max(viewBox[2], x + dx + symbol.overflowBox[2]);
          viewBox[3] = Math.max(viewBox[3], y + dy + symbol.overflowBox[3]);
        }
        x += symbol.width;
        viewBox[2] = Math.max(viewBox[2], x);
        if (symbol.height > rowHeight) {
          rowHeight = symbol.height;
        }
      }
      y += rowHeight;
      viewBox[3] = Math.max(viewBox[3], y);
    }
    viewBox[2] = viewBox[2] - viewBox[0];
    viewBox[3] = viewBox[3] - viewBox[1];
    levelOrder = ((function() {
      var results;
      results = [];
      for (level in levels) {
        results.push(level);
      }
      return results;
    })()).sort(function(x, y) {
      return x - y;
    });
    for (o = 0, len4 = levelOrder.length; o < len4; o++) {
      level = levelOrder[o];
      ref8 = levels[level];
      for (p = 0, len5 = ref8.length; p < len5; p++) {
        node = ref8[p];
        svg.appendChild(node);
      }
    }
    svg.setAttributeNS(SVGNS, 'viewBox', viewBox.join(' '));
    svg.setAttributeNS(SVGNS, 'width', viewBox[2]);
    svg.setAttributeNS(SVGNS, 'height', viewBox[3]);
    svg.setAttributeNS(SVGNS, 'preserveAspectRatio', 'xMinYMin meet');
    out = new XMLSerializer().serializeToString(doc);
    out = out.replace(/\sxmlns:xlink=""/g, '');
    return '<?xml version="1.0" encoding="UTF-8" standalone="no"?>\n<!DOCTYPE svg PUBLIC "-//W3C//DTD SVG 1.1//EN" "http://www.w3.org/Graphics/SVG/1.1/DTD/svg11.dtd">\n' + prettyXML(out);
  };

  return Drawing;

})(Input);

ASCIIDrawing = (function(superClass) {
  extend(ASCIIDrawing, superClass);

  function ASCIIDrawing() {
    return ASCIIDrawing.__super__.constructor.apply(this, arguments);
  }

  ASCIIDrawing.title = "ASCII drawing (one character per symbol)";

  ASCIIDrawing.parse = function(data) {
    return this.load(splitIntoLines(data));
  };

  return ASCIIDrawing;

})(Drawing);

DSVDrawing = (function(superClass) {
  extend(DSVDrawing, superClass);

  function DSVDrawing() {
    return DSVDrawing.__super__.constructor.apply(this, arguments);
  }

  DSVDrawing.parse = function(data) {
    var ref;
    if (data.slice(-2) === '\r\n') {
      data = data.slice(0, -2);
    } else if ((ref = data.slice(-1)) === '\r' || ref === '\n') {
      data = data.slice(0, -1);
    }
    return this.load(require('csv-parse/lib/sync')(data, {
      delimiter: this.delimiter,
      relax_column_count: true
    }));
  };

  return DSVDrawing;

})(Drawing);

SSVDrawing = (function(superClass) {
  extend(SSVDrawing, superClass);

  function SSVDrawing() {
    return SSVDrawing.__super__.constructor.apply(this, arguments);
  }

  SSVDrawing.title = "Space-delimiter drawing (one word per symbol)";

  SSVDrawing.delimiter = ' ';

  SSVDrawing.parse = function(data) {
    return SSVDrawing.__super__.constructor.parse.call(this, data.replace(/[ \t\f\v]+/g, ' '));
  };

  return SSVDrawing;

})(DSVDrawing);

CSVDrawing = (function(superClass) {
  extend(CSVDrawing, superClass);

  function CSVDrawing() {
    return CSVDrawing.__super__.constructor.apply(this, arguments);
  }

  CSVDrawing.title = "Comma-separated drawing (spreadsheet export)";

  CSVDrawing.delimiter = ',';

  return CSVDrawing;

})(DSVDrawing);

TSVDrawing = (function(superClass) {
  extend(TSVDrawing, superClass);

  function TSVDrawing() {
    return TSVDrawing.__super__.constructor.apply(this, arguments);
  }

  TSVDrawing.title = "Tab-separated drawing (spreadsheet export)";

  TSVDrawing.delimiter = '\t';

  return TSVDrawing;

})(DSVDrawing);

Drawings = (function(superClass) {
  extend(Drawings, superClass);

  Drawings.filenameSeparator = '_';

  function Drawings(drawings) {
    this.drawings = drawings;
  }

  Drawings.load = function(datas) {
    var data, drawing;
    return new this((function() {
      var k, len, results;
      results = [];
      for (k = 0, len = datas.length; k < len; k++) {
        data = datas[k];
        drawing = Drawing.load(data);
        drawing.subname = data.subname;
        results.push(drawing);
      }
      return results;
    })());
  };

  Drawings.prototype.writeSVG = function(mappings, filename) {
    var drawing, filename2, k, len, ref, results;
    ref = this.drawings;
    results = [];
    for (k = 0, len = ref.length; k < len; k++) {
      drawing = ref[k];
      results.push(drawing.writeSVG(mappings, this.drawings.length > 1 ? (filename2 = path.parse(filename != null ? filename : this.filename), filename2.base = filename2.base.slice(0, -filename2.ext.length), filename2.base += this.constructor.filenameSeparator + drawing.subname, filename2.base += '.svg', path.format(filename2)) : (drawing.filename = this.filename, filename)));
    }
    return results;
  };

  return Drawings;

})(Input);

XLSXDrawings = (function(superClass) {
  extend(XLSXDrawings, superClass);

  function XLSXDrawings() {
    return XLSXDrawings.__super__.constructor.apply(this, arguments);
  }

  XLSXDrawings.encoding = 'binary';

  XLSXDrawings.title = "Spreadsheet drawing(s) (Excel/OpenDocument/Lotus/dBASE)";

  XLSXDrawings.parse = function(data) {
    var rows, sheet, subname, workbook, xlsx;
    xlsx = require('xlsx');
    workbook = xlsx.read(data, {
      type: 'binary'
    });
    return this.load((function() {
      var k, len, ref, results;
      ref = workbook.SheetNames;
      results = [];
      for (k = 0, len = ref.length; k < len; k++) {
        subname = ref[k];
        sheet = workbook.Sheets[subname];
        if (subname.length === 31) {
          console.warn("Warning: Sheet '" + subname + "' has length exactly 31, which may be caused by Google Sheets export truncation");
        }
        rows = xlsx.utils.sheet_to_json(sheet, {
          header: 1,
          defval: ''
        });
        rows.subname = subname;
        results.push(rows);
      }
      return results;
    })());
  };

  return XLSXDrawings;

})(Drawings);

Context = (function() {
  function Context(symbols1, i1, j1) {
    var ref, ref1;
    this.symbols = symbols1;
    this.i = i1;
    this.j = j1;
    this.symbol = (ref = this.symbols[this.i]) != null ? ref[this.j] : void 0;
    this.key = (ref1 = this.symbol) != null ? ref1.key : void 0;
  }

  Context.prototype.neighbor = function(dj, di) {
    return new Context(this.symbols, this.i + di, this.j + dj);
  };

  Context.prototype.includes = function() {
    var args, ref;
    args = 1 <= arguments.length ? slice.call(arguments, 0) : [];
    return (this.symbol != null) && (ref = this.symbol).includes.apply(ref, args);
  };

  Context.prototype.row = function(di) {
    var i, j, k, len, ref, ref1, results, symbol;
    if (di == null) {
      di = 0;
    }
    i = this.i + di;
    ref1 = (ref = this.symbols[i]) != null ? ref : [];
    results = [];
    for (j = k = 0, len = ref1.length; k < len; j = ++k) {
      symbol = ref1[j];
      results.push(new Context(this.symbols, i, j));
    }
    return results;
  };

  Context.prototype.column = function(dj) {
    var i, j, k, len, ref, results, row;
    if (dj == null) {
      dj = 0;
    }
    j = this.j + dj;
    ref = this.symbols;
    results = [];
    for (i = k = 0, len = ref.length; k < len; i = ++k) {
      row = ref[i];
      results.push(new Context(this.symbols, i, j));
    }
    return results;
  };

  return Context;

})();

extensionMap = {
  '.txt': ASCIIMapping,
  '.js': JSMapping,
  '.coffee': CoffeeMapping,
  '.asc': ASCIIDrawing,
  '.ssv': SSVDrawing,
  '.csv': CSVDrawing,
  '.tsv': TSVDrawing,
  '.xlsx': XLSXDrawings,
  '.xlsm': XLSXDrawings,
  '.xlsb': XLSXDrawings,
  '.xls': XLSXDrawings,
  '.ods': XLSXDrawings,
  '.fods': XLSXDrawings,
  '.dif': XLSXDrawings,
  '.prn': XLSXDrawings,
  '.dbf': XLSXDrawings
};

svg2 = function(format, svg) {
  var filename, output;
  filename = path.parse(svg);
  if (filename.ext === ("." + format)) {
    filename.base += "." + format;
  } else {
    filename.base = filename.base.slice(0, -filename.ext.length) + "." + format;
  }
  output = path.format(filename);
  console.log('=>', output);
  output = require('child_process').spawnSync('inkscape', ['-z', "--file=" + svg, "--export-" + format + "=" + output]);
  if (output.error) {
    return console.error(output.error);
  }
};

help = function() {
  var extension, klass;
  console.log("Usage: " + process.argv[1] + " (...options and filenames...)\nDocumentation: https://github.com/edemaine/svgtiler#svg-tiler\n\nOptional arguments:\n  --help                Show this help message and exit.\n  -m / --margin         Don't delete blank extreme rows/columns\n  --tw TILE_WIDTH / --tile-width TILE_WIDTH\n                        Force all symbol tiles to have specified width\n  --th TILE_HEIGHT / --tile-height TILE_HEIGHT\n                        Force all symbol tiles to have specified height\n  -p / --pdf            Convert output SVG files to PDF via Inkscape\n  -P / --png            Convert output SVG files to PNG via Inkscape\n\nFilename arguments:  (mappings before drawings!)\n");
  for (extension in extensionMap) {
    klass = extensionMap[extension];
    if (extension.length < 10) {
      extension += ' '.repeat(10 - extension.length);
    }
    console.log("  *" + extension + "  " + klass.title);
    if (klass.help != null) {
      console.log("               " + klass.help);
    }
  }
  console.log("\nSYMBOL specifiers:  (omit the quotes in anything except .js and .coffee files)\n\n  'filename.svg':   load SVG from specified file\n  'filename.png':   include PNG image from specified file\n  'filename.jpg':   include JPEG image from specified file\n  '<svg>...</svg>': raw SVG\n  -> ...@key...:    function computing SVG, with `this` bound to Context with\n                    `key` set to symbol name, `i` and `j` set to coordinates,\n                    and supporting `neighbor` and `includes` methods.");
  return process.exit();
};

main = function() {
  var arg, args, filename, filenames, files, format, formats, i, input, k, l, len, len1, len2, m, mappings, skip;
  mappings = new Mappings;
  args = process.argv.slice(2);
  files = skip = 0;
  formats = [];
  for (i = k = 0, len = args.length; k < len; i = ++k) {
    arg = args[i];
    if (skip) {
      skip--;
      continue;
    }
    switch (arg) {
      case '-h':
      case '--help':
        help();
        break;
      case '-m':
      case '--margin':
        Drawing.keepMargins = true;
        break;
      case '--tw':
      case '--tile-width':
        Symbol.forceWidth = parseFloat(args[i + 1]);
        skip = 1;
        break;
      case '--th':
      case '--tile-height':
        Symbol.forceHeight = parseFloat(args[i + 1]);
        skip = 1;
        break;
      case '-p':
      case '--pdf':
        formats.push('pdf');
        break;
      case '-P':
      case '--png':
        formats.push('png');
        break;
      default:
        files++;
        console.log('*', arg);
        input = Input.load(arg);
        if (input instanceof Mapping) {
          mappings.push(input);
        } else if (input instanceof Drawing || input instanceof Drawings) {
          filenames = input.writeSVG(mappings);
          for (l = 0, len1 = formats.length; l < len1; l++) {
            format = formats[l];
            if (typeof filenames === 'string') {
              svg2(format, filenames);
            } else {
              for (m = 0, len2 = filenames.length; m < len2; m++) {
                filename = filenames[m];
                svg2(format, filename);
              }
            }
          }
        }
    }
  }
  if (!files) {
    console.log('Not enough filename arguments');
    return help();
  }
};

if (typeof window === "undefined" || window === null) {
  main();
}
