#!/usr/bin/env node
;
var ASCIIDrawing, ASCIIMapping, CSVDrawing, CoffeeMapping, CoffeeScript, Context, DOMParser, DSVDrawing, Drawing, DynamicSymbol, Input, JSMapping, Mapping, Mappings, SSVDrawing, SVGNS, SVGTilerException, StaticSymbol, Symbol, TSVDrawing, XLINKNS, XMLSerializer, csvParse, domImplementation, extension_map, fs, help, main, path, prettyXML, splitIntoLines, svgBBox, whitespace, xmldom,
  indexOf = [].indexOf || function(item) { for (var i = 0, l = this.length; i < l; i++) { if (i in this && this[i] === item) return i; } return -1; },
  extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty,
  slice = [].slice;

path = require('path');

fs = require('fs');

CoffeeScript = require('coffee-script');

csvParse = require('csv-parse/lib/sync');

xmldom = require('xmldom');

DOMParser = xmldom.DOMParser;

domImplementation = new xmldom.DOMImplementation();

XMLSerializer = xmldom.XMLSerializer;

prettyXML = require('prettify-xml');

SVGNS = 'http://www.w3.org/2000/svg';

XLINKNS = 'http://www.w3.org/1999/xlink';

splitIntoLines = function(data) {
  return data.replace('\r\n', '\n').replace('\r', '\n').split('\n');
};

whitespace = /[\s\uFEFF\xA0]+/;

SVGTilerException = (function() {
  function SVGTilerException(message) {
    this.message = message;
  }

  SVGTilerException.prototype.toString = function() {
    return "svgtiler: " + this.message;
  };

  return SVGTilerException;

})();

svgBBox = function(xml) {
  var recurse, viewBox;
  if (xml.documentElement.hasAttribute('viewBox')) {
    return xml.documentElement.getAttribute('viewBox').split(/\s*,?\s+/).map(parseFloat);
  } else {
    recurse = function(node) {
      var child, coord, cx, cy, point, points, r, ref, rx, ry, viewBox, viewBoxes, x1, x2, xmax, xmin, xs, y1, y2, ymax, ymin, ys;
      if (node.nodeType !== node.ELEMENT_NODE || ((ref = node.tagName) === 'defs' || ref === 'symbol' || ref === 'use')) {
        return [null, null, null, null];
      }
      switch (node.tagName) {
        case 'rect':
          return [parseFloat(node.getAttribute('x') || 0), parseFloat(node.getAttribute('y') || 0), parseFloat(node.getAttribute('width') || '100%'), parseFloat(node.getAttribute('height') || '100%')];
        case 'circle':
          cx = parseFloat(node.getAttribute('cx') || 0);
          cy = parseFloat(node.getAttribute('cy') || 0);
          r = parseFloat(node.getAttribute('r') || 0);
          return [cx - r, cy - r, 2 * r, 2 * r];
        case 'ellipse':
          cx = parseFloat(node.getAttribute('cx') || 0);
          cy = parseFloat(node.getAttribute('cy') || 0);
          rx = parseFloat(node.getAttribute('rx') || 0);
          ry = parseFloat(node.getAttribute('rx') || 0);
          return [cx - rx, cy - ry, 2 * rx, 2 * ry];
        case 'line':
          x1 = parseFloat(node.getAttribute('x1') || 0);
          y1 = parseFloat(node.getAttribute('y1') || 0);
          x2 = parseFloat(node.getAttribute('x2') || 0);
          y2 = parseFloat(node.getAttribute('y2') || 0);
          xmin = Math.min(x1, x2);
          ymin = Math.min(y1, y2);
          return [xmin, ymin, Math.max(x1, x2) - xmin, Math.max(y1, y2) - ymin];
        case 'polyline':
        case 'polygon':
          points = (function() {
            var k, len, ref1, results;
            ref1 = node.getAttribute('points').trim().split(/\s+/);
            results = [];
            for (k = 0, len = ref1.length; k < len; k++) {
              point = ref1[k];
              results.push((function() {
                var l, len1, ref2, results1;
                ref2 = point.split(/,/);
                results1 = [];
                for (l = 0, len1 = ref2.length; l < len1; l++) {
                  coord = ref2[l];
                  results1.push(parseFloat(coord));
                }
                return results1;
              })());
            }
            return results;
          })();
          xs = (function() {
            var k, len, results;
            results = [];
            for (k = 0, len = points.length; k < len; k++) {
              point = points[k];
              results.push(point[0]);
            }
            return results;
          })();
          ys = (function() {
            var k, len, results;
            results = [];
            for (k = 0, len = points.length; k < len; k++) {
              point = points[k];
              results.push(point[1]);
            }
            return results;
          })();
          xmin = Math.min.apply(Math, xs);
          ymin = Math.min.apply(Math, ys);
          return [xmin, ymin, Math.max.apply(Math, xs) - xmin, Math.max.apply(Math, ys) - ymin];
        default:
          viewBoxes = (function() {
            var k, len, ref1, results;
            ref1 = node.childNodes;
            results = [];
            for (k = 0, len = ref1.length; k < len; k++) {
              child = ref1[k];
              results.push(recurse(child));
            }
            return results;
          })();
          xmin = Math.min.apply(Math, (function() {
            var k, len, results;
            results = [];
            for (k = 0, len = viewBoxes.length; k < len; k++) {
              viewBox = viewBoxes[k];
              if (viewBox[0]) {
                results.push(viewBox[0]);
              }
            }
            return results;
          })());
          ymin = Math.min.apply(Math, (function() {
            var k, len, results;
            results = [];
            for (k = 0, len = viewBoxes.length; k < len; k++) {
              viewBox = viewBoxes[k];
              if (viewBox[1]) {
                results.push(viewBox[1]);
              }
            }
            return results;
          })());
          xmax = Math.max.apply(Math, (function() {
            var k, len, results;
            results = [];
            for (k = 0, len = viewBoxes.length; k < len; k++) {
              viewBox = viewBoxes[k];
              if (viewBox[0] && viewBox[2]) {
                results.push(viewBox[0] + viewBox[2]);
              }
            }
            return results;
          })());
          ymax = Math.max.apply(Math, (function() {
            var k, len, results;
            results = [];
            for (k = 0, len = viewBoxes.length; k < len; k++) {
              viewBox = viewBoxes[k];
              if (viewBox[1] && viewBox[3]) {
                results.push(viewBox[1] + viewBox[3]);
              }
            }
            return results;
          })());
          return [xmin, ymin, xmax - xmin, ymax - ymin];
      }
    };
    viewBox = recurse(xml.documentElement);
    if (indexOf.call(viewBox, 2e308) >= 0 || indexOf.call(viewBox, -2e308) >= 0) {
      return null;
    } else {
      return viewBox;
    }
  }
};

Symbol = (function() {
  function Symbol() {}

  Symbol.parse = function(key, data) {
    if (data == null) {
      throw new SVGTilerException("Attempt to create symbol '" + key + "' without data");
    } else if (typeof data === 'function') {
      return new DynamicSymbol(key, data);
    } else if (data["function"] != null) {
      return new DynamicSymbol(key, data["function"]);
    } else {
      return new StaticSymbol(key, typeof data === 'string' ? data.indexOf('<') < 0 ? {
        filename: data,
        svg: fs.readFileSync(filename, {
          encoding: this.encoding
        })
      } : {
        svg: data
      } : data);
    }
  };

  Symbol.prototype.includes = function(substring) {
    return this.key.indexOf(substring) >= 0;
  };

  return Symbol;

})();

StaticSymbol = (function(superClass) {
  extend(StaticSymbol, superClass);

  function StaticSymbol(key1, options) {
    var key, value, warnings;
    this.key = key1;
    for (key in options) {
      if (!hasProp.call(options, key)) continue;
      value = options[key];
      this[key] = value;
    }
    this.xml = new DOMParser().parseFromString(this.svg);
    this.viewBox = svgBBox(this.xml);
    this.width = this.height = null;
    if (this.viewBox != null) {
      this.width = this.viewBox[2];
      this.height = this.viewBox[3];
    }
    if (Symbol.forceWidth != null) {
      this.width = Symbol.forceWidth;
    }
    if (Symbol.forceHeight != null) {
      this.height = Symbol.forceHeight;
    }
    warnings = [];
    if (this.width == null) {
      warnings.push('width');
      if (this.width == null) {
        this.width = 0;
      }
    }
    if (this.height == null) {
      warnings.push('height');
      if (this.height == null) {
        this.height = 0;
      }
    }
    if (warnings.length > 0) {
      console.warn("Failed to detect " + (warnings.join(' and ')) + " of SVG for symbol '" + this.key + "'");
    }
  }

  StaticSymbol.prototype.id = function() {
    return 's' + this.key.replace(/[^-\w.\xC0-\xD6\xD8-\xF6\xF8-\u02FF\u0370-\u037D\u037F-\u1FFF\u200C-\u200D\u2070-\u218F\u2C00-\u2FEF\u3001-\uD7FF\uF900-\uFDCF\uFDF0-\uFFFD\xB7\u0300-\u036F\u203F-\u2040]/, function(m) {
      return ':' + m.charCodeAt(0).toString(16);
    });
  };

  return StaticSymbol;

})(Symbol);

DynamicSymbol = (function(superClass) {
  extend(DynamicSymbol, superClass);

  function DynamicSymbol(key1, func) {
    this.key = key1;
    this.func = func;
    this.versions = {};
    this.nversions = 0;
  }

  DynamicSymbol.prototype.use = function(context) {
    var result;
    result = this.func.call(context);
    if (result in this.versions) {
      return this.versions[result];
    } else {
      return this.versions[result] = Symbol.parse(this.key + "-v" + (this.nversions++), result);
    }
  };

  return DynamicSymbol;

})(Symbol);

Input = (function() {
  function Input() {}

  Input.encoding = 'utf8';

  Input.parseFile = function(filename) {
    var input;
    input = this.parse(fs.readFileSync(filename, {
      encoding: this.encoding
    }));
    input.filename = filename;
    return input;
  };

  Input.load = function(filename) {
    var extension;
    extension = path.extname(filename);
    if (extension in extension_map) {
      return extension_map[extension].parseFile(filename);
    } else {
      throw new SVGTilerException("Unrecognized extension in filename " + filename);
    }
  };

  return Input;

})();

Mapping = (function(superClass) {
  extend(Mapping, superClass);

  function Mapping(data) {
    this.map = {};
    if (typeof data === 'function') {
      this["function"] = data;
    } else {
      this.merge(data);
    }
  }

  Mapping.prototype.merge = function(data) {
    var key, results, value;
    results = [];
    for (key in data) {
      if (!hasProp.call(data, key)) continue;
      value = data[key];
      if (!(value instanceof Symbol)) {
        value = Symbol.parse(key, value);
      }
      results.push(this.map[key] = value);
    }
    return results;
  };

  Mapping.prototype.lookup = function(key) {
    if (key in this.map) {
      return this.map[key];
    } else if (this["function"] != null) {
      return this.map[key] = Symbol.parse(key, this["function"](key));
    } else {
      return void 0;
    }
  };

  return Mapping;

})(Input);

ASCIIMapping = (function(superClass) {
  extend(ASCIIMapping, superClass);

  function ASCIIMapping() {
    return ASCIIMapping.__super__.constructor.apply(this, arguments);
  }

  ASCIIMapping.title = "ASCII mapping file";

  ASCIIMapping.help = "Each line is <symbol-name><space><raw SVG or filename.svg>";

  ASCIIMapping.parse = function(data) {
    var k, key, len, line, map, ref, separator;
    map = {};
    ref = splitIntoLines(data);
    for (k = 0, len = ref.length; k < len; k++) {
      line = ref[k];
      separator = whitespace.exec(line);
      if (separator == null) {
        continue;
      }
      if (separator.index === 0) {
        key = line[0];
      } else {
        key = line.slice(0, separator.index);
      }
      map[key] = line.slice(separator.index + separator[0].length);
    }
    return new this(map);
  };

  return ASCIIMapping;

})(Mapping);

JSMapping = (function(superClass) {
  extend(JSMapping, superClass);

  function JSMapping() {
    return JSMapping.__super__.constructor.apply(this, arguments);
  }

  JSMapping.title = "JavaScript mapping file";

  JSMapping.help = "Object mapping symbol names to SYMBOL e.g. dot: 'dot.svg'";

  JSMapping.parse = function(data) {
    return new this(eval(data));
  };

  return JSMapping;

})(Mapping);

CoffeeMapping = (function(superClass) {
  extend(CoffeeMapping, superClass);

  function CoffeeMapping() {
    return CoffeeMapping.__super__.constructor.apply(this, arguments);
  }

  CoffeeMapping.title = "CoffeeScript mapping file";

  CoffeeMapping.help = "Object mapping symbol names to SYMBOL e.g. dot: 'dot.svg'";

  CoffeeMapping.parse = function(data) {
    return new this(CoffeeScript["eval"](data));
  };

  return CoffeeMapping;

})(Mapping);

Mappings = (function() {
  function Mappings(maps) {
    this.maps = maps != null ? maps : [];
  }

  Mappings.prototype.push = function(map) {
    return this.maps.push(map);
  };

  Mappings.prototype.lookup = function(key) {
    var i, k, ref, value;
    if (!this.maps.length) {
      return;
    }
    for (i = k = ref = this.maps.length - 1; ref <= 0 ? k <= 0 : k >= 0; i = ref <= 0 ? ++k : --k) {
      value = this.maps[i].lookup(key);
      if (value != null) {
        return value;
      }
    }
    return void 0;
  };

  return Mappings;

})();

Drawing = (function(superClass) {
  extend(Drawing, superClass);

  function Drawing(data1) {
    this.data = data1;
  }

  Drawing.prototype.writeSVG = function(mappings, filename) {
    if (filename == null) {
      filename = path.parse(this.filename);
      if (filename.ext === '.svg') {
        filename.base += '.svg';
      } else {
        filename.base = filename.base.slice(0, -filename.ext.length) + '.svg';
      }
      filename = path.format(filename);
    }
    console.log('->', filename);
    return fs.writeFileSync(filename, this.renderSVG(mappings));
  };

  Drawing.prototype.renderSVG = function(mappings) {
    var attribute, cell, child, doc, height, i, j, k, key, l, len, len1, len2, len3, missing, n, node, o, ref, ref1, ref2, ref3, row, rowHeight, svg, symbol, symbols, symbolsByKey, use, width, x, y;
    doc = domImplementation.createDocument(SVGNS, 'svg');
    svg = doc.documentElement;
    svg.setAttribute('xmlns:xlink', XLINKNS);
    svg.setAttribute('version', '1.1');
    missing = {};
    symbols = (function() {
      var k, len, ref, results;
      ref = this.data;
      results = [];
      for (k = 0, len = ref.length; k < len; k++) {
        row = ref[k];
        results.push((function() {
          var l, len1, results1;
          results1 = [];
          for (l = 0, len1 = row.length; l < len1; l++) {
            cell = row[l];
            symbol = mappings.lookup(cell);
            if (symbol == null) {
              missing[cell] = true;
            }
            results1.push(symbol);
          }
          return results1;
        })());
      }
      return results;
    }).call(this);
    missing = (function() {
      var results;
      results = [];
      for (key in missing) {
        if (!hasProp.call(missing, key)) continue;
        results.push("'" + key + "'");
      }
      return results;
    })();
    if (missing.length) {
      console.warn("Failed to recognize symbols:", missing.join(', '));
    }
    symbolsByKey = {};
    symbols = (function() {
      var k, len, results;
      results = [];
      for (i = k = 0, len = symbols.length; k < len; i = ++k) {
        row = symbols[i];
        results.push((function() {
          var l, len1, results1;
          results1 = [];
          for (j = l = 0, len1 = row.length; l < len1; j = ++l) {
            symbol = row[j];
            if ((symbol != null ? symbol.use : void 0) != null) {
              symbol = symbol.use(new Context(symbols, i, j));
            }
            results1.push(symbolsByKey[symbol != null ? symbol.key : void 0] = symbol);
          }
          return results1;
        })());
      }
      return results;
    })();
    for (key in symbolsByKey) {
      symbol = symbolsByKey[key];
      if (symbol == null) {
        continue;
      }
      svg.appendChild(node = doc.createElementNS(SVGNS, 'symbol'));
      node.setAttribute('id', symbol.id());
      if (symbol.viewBox != null) {
        node.setAttribute('viewBox', symbol.viewBox);
      }
      if ((ref = symbol.xml.documentElement.tagName) === 'svg' || ref === 'symbol') {
        ref1 = symbol.xml.documentElement.attributes;
        for (k = 0, len = ref1.length; k < len; k++) {
          attribute = ref1[k];
          if (!(((ref2 = attribute.name) === 'version') || attribute.name.slice(0, 5) === 'xmlns')) {
            node.setAttribute(attribute.name, attribute.value);
          }
        }
        ref3 = symbol.xml.documentElement.childNodes;
        for (l = 0, len1 = ref3.length; l < len1; l++) {
          child = ref3[l];
          node.appendChild(child.cloneNode(true));
        }
      } else {
        node.appendChild(symbol.xml.documentElement.cloneNode(true));
      }
    }
    width = 0;
    y = 0;
    for (i = n = 0, len2 = symbols.length; n < len2; i = ++n) {
      row = symbols[i];
      rowHeight = 0;
      x = 0;
      for (j = o = 0, len3 = row.length; o < len3; j = ++o) {
        symbol = row[j];
        if (symbol == null) {
          continue;
        }
        svg.appendChild(use = doc.createElementNS(SVGNS, 'use'));
        use.setAttribute('xlink:href', '#' + symbol.id());
        use.setAttributeNS(SVGNS, 'x', x);
        use.setAttributeNS(SVGNS, 'y', y);
        use.setAttributeNS(SVGNS, 'width', symbol.width);
        use.setAttributeNS(SVGNS, 'height', symbol.height);
        x += symbol.width;
        if (symbol.height > rowHeight) {
          rowHeight = symbol.height;
        }
      }
      if (x > width) {
        width = x;
      }
      y += rowHeight;
    }
    height = y;
    svg.setAttributeNS(SVGNS, 'viewBox', "0 0 " + width + " " + height);
    svg.setAttributeNS(SVGNS, 'width', width);
    svg.setAttributeNS(SVGNS, 'height', height);
    svg.setAttributeNS(SVGNS, 'preserveAspectRatio', 'xMinYMin meet');
    return '<?xml version="1.0" encoding="UTF-8" standalone="no"?>\n<!DOCTYPE svg PUBLIC "-//W3C//DTD SVG 1.1//EN" "http://www.w3.org/Graphics/SVG/1.1/DTD/svg11.dtd">\n' + prettyXML(new XMLSerializer().serializeToString(doc));
  };

  return Drawing;

})(Input);

ASCIIDrawing = (function(superClass) {
  extend(ASCIIDrawing, superClass);

  function ASCIIDrawing() {
    return ASCIIDrawing.__super__.constructor.apply(this, arguments);
  }

  ASCIIDrawing.title = "ASCII drawing (one character per symbol)";

  ASCIIDrawing.parse = function(data) {
    return new this(splitIntoLines(data));
  };

  return ASCIIDrawing;

})(Drawing);

DSVDrawing = (function(superClass) {
  extend(DSVDrawing, superClass);

  function DSVDrawing() {
    return DSVDrawing.__super__.constructor.apply(this, arguments);
  }

  DSVDrawing.parse = function(data) {
    var ref;
    if (data.slice(-2) === '\r\n') {
      data = data.slice(0, -2);
    } else if ((ref = data.slice(-1)) === '\r' || ref === '\n') {
      data = data.slice(0, -1);
    }
    return new this(csvParse(data, {
      delimiter: this.delimiter,
      relax_column_count: true
    }));
  };

  return DSVDrawing;

})(Drawing);

SSVDrawing = (function(superClass) {
  extend(SSVDrawing, superClass);

  function SSVDrawing() {
    return SSVDrawing.__super__.constructor.apply(this, arguments);
  }

  SSVDrawing.title = "Space-delimiter drawing (one word per symbol)";

  SSVDrawing.delimiter = ' ';

  SSVDrawing.parse = function(data) {
    return SSVDrawing.__super__.constructor.parse.call(this, data.replace(/[ \t\f\v]+/g, ' '));
  };

  return SSVDrawing;

})(DSVDrawing);

CSVDrawing = (function(superClass) {
  extend(CSVDrawing, superClass);

  function CSVDrawing() {
    return CSVDrawing.__super__.constructor.apply(this, arguments);
  }

  CSVDrawing.title = "Comma-separated drawing (spreadsheet export)";

  CSVDrawing.delimiter = ',';

  return CSVDrawing;

})(DSVDrawing);

TSVDrawing = (function(superClass) {
  extend(TSVDrawing, superClass);

  function TSVDrawing() {
    return TSVDrawing.__super__.constructor.apply(this, arguments);
  }

  TSVDrawing.title = "Tab-separated drawing (spreadsheet export)";

  TSVDrawing.delimiter = '\t';

  return TSVDrawing;

})(DSVDrawing);

Context = (function() {
  function Context(symbols1, i1, j1) {
    var ref, ref1;
    this.symbols = symbols1;
    this.i = i1;
    this.j = j1;
    this.symbol = (ref = this.symbols[this.i]) != null ? ref[this.j] : void 0;
    this.key = (ref1 = this.symbol) != null ? ref1.key : void 0;
  }

  Context.prototype.includes = function() {
    var args, ref;
    args = 1 <= arguments.length ? slice.call(arguments, 0) : [];
    return (this.symbol != null) && (ref = this.symbol).includes.apply(ref, args);
  };

  Context.prototype.neighbor = function(dj, di) {
    return new Context(this.symbols, this.i + di, this.j + dj);
  };

  return Context;

})();

extension_map = {
  '.txt': ASCIIMapping,
  '.js': JSMapping,
  '.coffee': CoffeeMapping,
  '.asc': ASCIIDrawing,
  '.ssv': SSVDrawing,
  '.csv': CSVDrawing,
  '.tsv': TSVDrawing
};

help = function() {
  var extension, klass;
  console.log("Usage: " + process.argv[1] + " (...options and filenames...)\n\nOptional arguments:\n  --help                Show this help message and exit.\n  --tw TILE_WIDTH / --tile-width TILE_WIDTH\n                        Force all symbol tiles to have specified width\n                        (default: null, which means read width from SVG)\n  --th TILE_HEIGHT / --tile-height TILE_HEIGHT\n                        Force all symbol tiles to have specified height\n                        (default: null, which means read height from SVG)\n\nFilename arguments:  (mappings before drawings!)\n");
  for (extension in extension_map) {
    klass = extension_map[extension];
    if (extension.length < 10) {
      extension += ' '.repeat(10 - extension.length);
    }
    console.log("  *" + extension + "  " + klass.title);
    if (klass.help != null) {
      console.log("               " + klass.help);
    }
  }
  console.log("\nSYMBOL specifiers:\n\n  'filename.svg':   load SVG from specifies file\n  '<svg>...</svg>': raw SVG\n  -> ...:           function computing SVG, with context available as this/@");
  return process.exit();
};

main = function() {
  var arg, args, files, i, input, k, len, mappings, skip;
  mappings = new Mappings;
  args = process.argv.slice(2);
  files = skip = 0;
  for (i = k = 0, len = args.length; k < len; i = ++k) {
    arg = args[i];
    if (skip) {
      skip--;
      continue;
    }
    switch (arg) {
      case '-h':
      case '--help':
        help();
        break;
      case '--tw':
      case '--tile-width':
        Symbol.forceWidth = parseFloat(args[i + 1]);
        skip = 1;
        break;
      case '--th':
      case '--tile-height':
        Symbol.forceHeight = parseFloat(args[i + 1]);
        skip = 1;
        break;
      default:
        files++;
        console.log('*', arg);
        input = Input.load(arg);
        if (input instanceof Mapping) {
          mappings.push(input);
        } else if (input instanceof Drawing) {
          input.writeSVG(mappings);
        }
    }
  }
  if (!files) {
    console.log('Not enough filename arguments');
    return help();
  }
};

if (typeof window === "undefined" || window === null) {
  main();
}
